rom trac.wiki.macros import WikiMacroBase
from trac.util import escape
from StringIO import StringIO
import csv

class CSVMacro(WikiMacroBase):
    '''
    0.11 Port of CSV Macro.
    See http://trac-hacks.org/wiki/CsvMacro
    '''

    def render_macro(self, req, name, content):
        sniffer = csv.Sniffer()
        content = content.encode('ascii', 'replace')
        reader = csv.reader(StringIO(content), sniffer.sniff(content))
        out = StringIO()
        out.write('<table class="wiki">\n')
        for row in reader:
            out.write('<tr>')
            for col in row:
                out.write('<td>%s</td>' % escape(col))
            out.write('</tr>\n')
        out.write('</table>\n')
        return out.getvalue()